YUI.add('gallery-bidi-textinput', function(Y) {

// Adds a plugin to text input fields to change their bidi direction
// automatically based on the value entered by the user in the field. So if
// the user starts typing in Arabic in a left-to-right text input box, the
// direction of the box will automatically switch to right-to-left, so the
// text could be displayed properly.

function BidiTextInputPlugin() {
    BidiTextInputPlugin.superclass.constructor.apply(this, arguments);
}

BidiTextInputPlugin.NS = "bidiTextInput";
BidiTextInputPlugin.NAME = "bidiTextInput";

Y.extend(BidiTextInputPlugin, Y.Plugin.Base, {
    initializer: function () {
        this.afterHostEvent("valueChange", function () {
            var host = this.get("host"),
                inputValue = host.get("value"),
                direction = Y.Intl.bidiDirection(inputValue);
            
            host.setDirection(direction);
        });
    }
});

Y.namespace('Plugin');
Y.Plugin.BidiTextInput = BidiTextInputPlugin;


}, 'gallery-2010.09.08-19-45' ,{requires:['plugin','event-valuechange','gallery-intl-bidi','gallery-node-setdir']});
